/*
 * Kyoto Microcomputer PARTNER Linux support
 */



#ifndef	__KMC_H__ /* { */
#define	__KMC_H__

#include "__brk_code.h"


#ifdef CONFIG_KMC_PATCH /* { */

#ifdef MODULE /* { */
#if defined(CONFIG_KMC_MODULE_AUTO) && defined(__KMC_MODULE_DEBUG) /* { */

#include <linux/version.h>

void __kmc_module_debug_start(void);
void __kmc_module_debug_end(void);

void __kmc_driver_start(void);
void __kmc_driver_end(void);
void __kmc_driver_init_end(void);

char __kmc_driver_tmp __attribute__ ((section (".bss"))) ;

#ifdef CONFIG_KMC_ICE_CHK_MOD_DEB /* { */
 #define __KMC_ICE_CHK()						\
    {int ret;								\
    extern asmlinkage int sys_ptrace(long request, long pid, long addr, long data);									\
    if(0x434D4B00 != (0xffffff00&(ret=sys_ptrace(0x4B4D4300,0,0,0)))){	\
	return;								\
    }									\
    if(0 == (0x000000ff&ret)){						\
	return;								\
    }									\
    }
#else /* }{ !CONFIG_KMC_ICE_CHK_MOD_DEB */
 #define __KMC_ICE_CHK()
#endif /* } CONFIG_KMC_ICE_CHK_MOD_DEB */


#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) /* { */
static void __kmc_driver(void)
{
    asm("   .text");
    asm("   .long   0x4c434d83");
    asm("__kmc_driver_init_end:");
    __KMC_BRK_CODE();
    asm("   .long   0x4c434d82");
    asm("__kmc_driver_end:");
    __KMC_BRK_CODE();
    asm("   .long   0x4c434d81");
    asm("__kmc_driver_start:");
    __KMC_BRK_CODE();
    asm("   .long   0x4c434d80");
    asm("   .long   __kmc_driver_name");
    asm("   .long   __kmc_driver_tmp");
    asm("   .long   0x4c434d8f");
    asm("   .long   __kmc_init_text");
    asm("   .long   __kmc_exit_text");
    asm("   .long   __kmc_init_data");
    asm("   .long   __kmc_exit_data");
}

__exitdata int __kmc_exit_data;
__initdata int __kmc_init_data;

void __init __kmc_init_text(void)
{
    __KMC_ICE_CHK();
    __kmc_driver_start();
}

void __init __kmc_init_text_finish(void)
{
    __kmc_driver_init_end();
}

void __exit __kmc_exit_text(void)
{
    __KMC_ICE_CHK();
    __kmc_driver_end();
}

#define	__kmc_module_debug_start	__kmc_init_text
#define	__kmc_module_debug_end		__kmc_exit_text

#else /* }{ LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0) */
static void __kmc_driver(void)
{
    asm("   .text");
    asm("   .long   0x4c434d82");
    asm("__kmc_driver_end:");
    __KMC_BRK_CODE();
    asm("   .long   0x4c434d81");
    asm("__kmc_driver_start:");
    __KMC_BRK_CODE();
    asm("   .long   0x4c434d80");
    asm("   .long   __kmc_driver_name");
    asm("   .long   __kmc_driver_tmp");
}

void
__kmc_module_debug_start(void)
{
    __KMC_ICE_CHK();
    __kmc_driver_start();
}

void
__kmc_module_debug_end(void)
{
    __KMC_ICE_CHK();
    __kmc_driver_end();
}
#endif /* } LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) */

#if defined(__KMC_MODULE_NAME) /* { */
static char __kmc_driver_name[] = __KMC_MODULE_NAME;
#else /* }{ */
static char __kmc_driver_name[] = __KMC_OBJ_NAME;
#endif /* } defined(__KMC_MODULE_NAME) */


// RpCɂČx
#undef	module_init
#undef	module_exit

#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) /* { */
#define module_init(initfn)						\
	int init_module(void)						\
	{int ret; __kmc_init_text(); ret = initfn();			\
	__kmc_init_text_finish(); return ret;}
#define module_exit(exitfn)						\
	void cleanup_module(void)					\
	{ exitfn(); __kmc_exit_text(); }

#else /* }{ LINUX_VERSION_CODE < KERNEL_VERSION(2,6,0) */
#define module_init(x)							\
	int init_module(void)						\
	{ __kmc_module_debug_start(); return x(); }			\
	static inline __init_module_func_t __init_module_inline(void)	\
	{ return x; }
#define module_exit(x)							\
	void cleanup_module(void)					\
	{ x(); __kmc_module_debug_end(); }				\
	static inline __cleanup_module_func_t __cleanup_module_inline(void) \
	{ return x; }
#endif /* } LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,0) */

#endif /* } defined(CONFIG_KMC_MODULE_AUTO) && defined(__KMC_MODULE_DEBUG) */


#else /* }{ !MODULE */

/* ########## kernel/exit.c { ########## */
#ifdef CONFIG_KMC_PARTNER_COLLECT_THREAD_OFF /* { */
#define	__KMC_MAX_PT_COUNT	32

extern struct task_struct *__kmc_tss_list[__KMC_MAX_PT_COUNT + 1];

static inline void __kmc_do_exit__(struct task_struct *tsk)
{
    int i;
    extern void __kmc_do_exit(void);

    if(__kmc_tss_list[0]!=0){
	for(i=1;i<(__KMC_MAX_PT_COUNT + 1);++i){
	    if(__kmc_tss_list[i]==tsk){
		__kmc_tss_list[0]=(struct task_struct *)i;
		__kmc_do_exit();
	    }
	}
    }
}
#else /* }{ !CONFIG_KMC_PARTNER_COLLECT_THREAD_OFF */
#define	__KMC_MAX_THREAD_COUNT	32
#define	__KMC_MAX_PT_COUNT	16

extern struct task_struct *__kmc_tss_list_array[__KMC_MAX_PT_COUNT + 1][__KMC_MAX_THREAD_COUNT];

static inline void __kmc_do_exit__(struct task_struct *tsk)
{
    int i;
    extern void __kmc_do_exit(void);

    if(__kmc_tss_list_array[0][0] != 0){
	for(i = 1; i < (__KMC_MAX_PT_COUNT + 1); ++i){
	    int j;
	    struct task_struct **tpp;
	    struct task_struct *tp;

	    tpp = __kmc_tss_list_array[i];
	    for(j = 0; j < __KMC_MAX_THREAD_COUNT; ++j){
		tp = *(tpp++);
		if(tp == 0) break;
		if(tp == tsk){
		    while(j < (__KMC_MAX_THREAD_COUNT - 1)){
			if(*tpp == 0) break;
			*(tpp -1 ) = *tpp;
			*tpp = tsk;
			++tpp; ++j;
		    }
		    __kmc_tss_list_array[0][0] = (struct task_struct *)i;
		    __kmc_tss_list_array[0][1] = (struct task_struct *)j;
		    __kmc_do_exit();
		    i = (__KMC_MAX_PT_COUNT + 1);
		    break;
		}
	    }
	}
    }
}
#endif /* } CONFIG_KMC_PARTNER_COLLECT_THREAD_OFF */
#define	__KMC_DO_EXIT(t)	__kmc_do_exit__(t)
/* ########## kernel/exit.c } ########## */

/* ########## kernel/timer.c { ########## */
#ifdef CONFIG_KMC_PARTNER_VIRTUAL_ICE_OFF /* { */
#define	__KMC_SYS_GETPID()
#else /* }{ !CONFIG_KMC_PARTNER_VIRTUAL_ICE_OFF */
#define	__KMC_SYS_GETPID()						\
	{								\
		extern int __kmc_sys_getpid_flag;			\
		extern void __kmc_sys_getpid(void);			\
		if(__kmc_sys_getpid_flag) __kmc_sys_getpid();		\
	}
#endif /* } CONFIG_KMC_PARTNER_VIRTUAL_ICE_OFF */
/* ########## kernel/timer.c } ########## */

/* ########## kernel/sched.c { ########## */
#ifdef CONFIG_KMC_TRACE_EXT_OFF /* { */
#define	__KMC_SCHED_CALL(p,n)
#else /* }{ !CONFIG_KMC_TRACE_EXT_OFF */
#define KMC_MAX_SHEDULE_LIST    1024
#define	__KMC_SCHED_CALL(p,n)						\
	{								\
		extern void (*__kmc_schedule_call)(struct task_struct *,struct task_struct *);								\
		__kmc_schedule_call(p,n);				\
	}
#endif /* CONFIG_KMC_TRACE_EXT_OFF } */
/* ########## kernel/sched.c } ########## */

/* ########## kernel/ksyms.c { ########## */
#ifdef CONFIG_KMC_ICE_CHK_MOD_DEB /* { */
#define	__KMC_EXPORT_SYMBOL_PTRACE()					\
	extern asmlinkage int sys_ptrace(long request, long pid, long addr, long data);									\
	EXPORT_SYMBOL(sys_ptrace)
#else /* }{ !CONFIG_KMC_ICE_CHK_MOD_DEB */
#define	__KMC_EXPORT_SYMBOL_PTRACE()
#endif /* } CONFIG_KMC_ICE_CHK_MOD_DEB */
/* ########## kernel/ksyms.c } ########## */

/* ########## arch/XXX/kernel/ptrace.c { ########## */
#ifdef CONFIG_KMC_PARTNER_AVAILABLE_OFF /* { */
#define	__KMC_CHECK_PTRACE_REQUEST(req,r)
#else /* }{ !CONFIG_KMC_PARTNER_AVAILABLE_OFF */
#define	__KMC_CHECK_PTRACE_REQUEST(req,r)		\
		if(req == 0x4B4D4300){			\
			extern int __kmc_available_ice;	\
			r = __kmc_available_ice;	\
			goto out;			\
		}
#endif /* } CONFIG_KMC_PARTNER_AVAILABLE_OFF */
/* ########## arch/XXX/kernel/ptrace.c } ########## */


#endif /* } MODULE */
#else /* }{ !CONFIG_KMC_PATCH */

#define	__KMC_SCHED_CALL(p,n)
#define	__KMC_DO_EXIT(t)
#define	__KMC_SYS_GETPID()
#define	__KMC_EXPORT_SYMBOL_PTRACE()
#define	__KMC_CHECK_PTRACE_REQUEST(req,r)


#endif /* } CONFIG_KMC_PATCH */


#endif /* } __KMC_H__ */
